ifndef _CSmiley_
_CSmiley_ equ 1

; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   CSmiley_Init    PROTO :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   CSmiley_destructorPto    TYPEDEF  PROTO  :DWORD 
   CSmiley_enableStepsPto	TYPEDEF	 PROTO	:DWORD, :DWORD
   CSmiley_setStepsDCPto	TYPEDEF	 PROTO	:DWORD, :DWORD
   CSmiley_drawPto			TYPEDEF	 PROTO  :DWORD
; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   CLASS CSmiley
   	  ; inherited class!
   	  CSprite		<>
   	  ; other methods:
      CMETHOD		enableSteps
      CMETHOD		setStepsDC
      ; varibles:
      fStepsEnabled	dd	?		;set if steps are on
      dcSteps		dd	?
      hStepsBitmap	dd	?
      dcStepsBitmap	dd	?
   CSmiley ENDS

.data

   BEGIN_INIT 
      dd offset CSmiley_destructor
      dd offset CSmiley_enableSteps
      dd offset CSmiley_setStepsDC
      dd 0		;fStepsEnabled, 0 by default
      dd 0		;dcSteps
      dd 0		;hStepsBitmap
      dd 0		;dcStepsBitmap
   END_INIT


.code
; --=====================================================================================--
; CLASS CONSTRUCTOR
; --=====================================================================================--
CSmiley_Init  PROC uses edi esi lpTHIS:DWORD
   SET_CLASS CSmiley INHERITS CSprite
   SetObject edi, CSmiley
	
   OVERRIDE	  draw, CSmiley_draw
   invoke	  GetModuleHandle, 0
   invoke	  LoadBitmap, eax, 300
   mov		  [edi].hStepsBitmap, eax
   invoke	  CreateCompatibleDC, NULL
   mov		  [edi].dcStepsBitmap, eax
   invoke	  SelectObject, eax, [edi].hStepsBitmap
   

   ReleaseObject edi
   ret
CSmiley_Init ENDP

; --=====================================================================================--
; destructor METHOD BEHAVIOR
; --=====================================================================================--
CSmiley_destructor  PROC uses edi lpTHIS:DWORD 
   SetObject edi, CSmiley

   mov eax, [edi].dcStepsBitmap
   .IF	eax
   		invoke	DeleteDC, eax
   .ENDIF
   
   mov eax, [edi].hStepsBitmap
   .IF eax
   		invoke	DeleteObject, eax
   .ENDIF

   SUPER	destructor 

   ReleaseObject edi
   ret
CSmiley_destructor  ENDP

; --=====================================================================================--
; setBitmap
; --=====================================================================================--
CSmiley_draw  PROC uses edi lpTHIS:DWORD
   SetObject edi, CSmiley
 
   SUPER	draw
   .IF		[edi].fStepsEnabled
	   invoke	RAND32, 3
	   shl		eax, 4 ; * 16 pixels
	   
	
	   invoke	BitBlt, [edi].dcSteps, [edi].xPos, [edi].yPos, \	
						16, 16, [edi].dcStepsBitmap, eax, 0, SRCAND	
   .ENDIF
   ReleaseObject edi
   ret
CSmiley_draw ENDP
   
; --=====================================================================================--
; setStepsDC
; --=====================================================================================--
CSmiley_setStepsDC  PROC uses edi lpTHIS:DWORD, hDC:DWORD
   SetObject edi, CSmiley
   mov 	eax, hDC
   mov	[edi].dcSteps, eax
   
   ReleaseObject edi
   ret
CSmiley_setStepsDC ENDP
; --=====================================================================================--
; enableSteps
; --=====================================================================================--
CSmiley_enableSteps  PROC uses edi lpTHIS:DWORD, flag:DWORD
   SetObject edi, CSmiley
   mov 	eax, flag
   mov	[edi].fStepsEnabled, eax
   
   ReleaseObject edi
   ret
CSmiley_enableSteps ENDP


 
endif